package com.jiuqi.util.biff;

import java.util.Date;
import com.jiuqi.util.StreamException;
import com.jiuqi.util.Stream;

public class BIFFWriter extends BIFFFiler
{
    public BIFFWriter() {
    }
    
    public BIFFWriter(final Stream stream) {
        super(stream);
    }
    
    public void write() throws StreamException {
        this.stream.write(this.biff.getSign());
        this.stream.writeInt(this.biff.getSize());
        this.stream.copyFrom(this.biff.getData(), 0L);
    }
    
    public void write(final byte sign) throws StreamException {
        this.biff.reset(sign);
        this.write();
    }
    
    public void write(final byte sign, final int value) throws StreamException {
        this.biff.reset(sign);
        this.biff.getData().writeInt(value);
        this.write();
    }
    
    public void write(final byte sign, final double value) throws StreamException {
        this.biff.reset(sign);
        this.biff.getData().writeDouble(value);
        this.write();
    }
    
    public void write(final byte sign, final String value) throws StreamException {
        this.biff.reset(sign);
        if (value != null) {
            this.biff.getData().writeString(value);
        }
        this.write();
    }
    
    public void write(final byte sign, final boolean value) throws StreamException {
        this.biff.reset(sign);
        this.biff.getData().writeBool(value);
        this.write();
    }
    
    public void write(final byte sign, final long value) throws StreamException {
        this.biff.reset(sign);
        this.biff.getData().writeLong(value);
        this.write();
    }
    
    public void write(final byte sign, final Date value) throws StreamException {
        this.biff.reset(sign);
        this.biff.getData().writeLong(value.getTime());
        this.write();
    }
    
    public void write(final byte sign, final byte[] value) throws StreamException {
        this.biff.reset(sign);
        this.biff.getData().writeBuffer(value, 0, value.length);
        this.write();
    }
    
    public void writeEOF() throws StreamException {
        this.write(this.eofSign);
    }
}
